# -*- coding: utf-8 -*-


class ReportGenerationException(Exception):
    """Ошибка создания отчета"""


class SendReportException(Exception):
    """Ошибка отправки отчета"""
    def __init__(self):
        self.message = "Ошибка при отправке данных по МО"
        super(SendReportException, self).__init__(self.message)


class ConnectingAtSendingReportException(Exception):
    """Ошибка соедиения при отправке отчета"""
    def __init__(self):
        self.message = (
            "Ошибка соединения с удаленным сервером "
            "при отправке данных по МО")
        super(ConnectingAtSendingReportException, self).__init__(self.message)


class SOAPClientCreateException(Exception):
    """Ошибка создания SOAP клиента"""

    def __init__(self):
        self.message = 'Ошибка при создании SOAP клиента'
        super(SOAPClientCreateException, self).__init__(self.message)


class ReportFormRowLogicException(Exception):
    """Ошибка в логике сохранения модели ReportFormRow"""


class LostReportFormRowException(Exception):
    """Исключение которое генерируется в случае если отчетность собрана а,
       данные отсутствуют"""


class XMLException(Exception):
    """Исключение при формировании файла"""


class XMLRenderException(XMLException):
    """Исключение возникающее при рендеринге XML"""
    def __init__(self):
        self.message = "Ошибка при формировании XML"
        super(XMLRenderException, self).__init__(self.message)


class XMLWriteException(XMLException):
    """Исключение возникающее при записи XML файла"""


class DocumentCreateException(Exception):
    """Ошибка при создании документа"""

    def __init__(self):

        self.message = (
            'Ошибка при формировании '
            'документа по МО')
        super(DocumentCreateException, self).__init__(self.message)


class NoDataInMo(Exception):
    """
    В МО нет садов по которым собираются данные
    """

    def __init__(self, message=None):

        self.message = message or (
            'В МО нет садов '
            'для отправки в ЛКИ')
        super(NoDataInMo, self).__init__(self.message)
